<template>
  <teleport to="body">
    <div v-if="show" @click="tryClose" class="backdrop"></div>
    <transition name="dialog">
      <dialog open v-if="show">
        <header>
          <slot name="header">
            <h2>{{ title }}</h2>
          </slot>
        </header>
        <section>
          <slot></slot>
        </section>
        <menu>
          <slot name="actions">
            <base-button @click="tryClose">Close</base-button>
          </slot>
        </menu>
      </dialog>
    </transition>
  </teleport>
</template>

<script>
export default {
  props: {
    show: {
      type: Boolean,
      required: true,
    },
    title: {
      type: String,
      required: false,
    },
    fixed: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  emits: ["close"],
  methods: {
    tryClose() {
      if (this.fixed) {
        return;
      }
      this.$emit("close");
    },
  },
};
</script>

<style scoped>
.backdrop {
  position: fixed;
  top: 0;
  left: 0;
  height: 100vh;
  width: 100%;
  background-color: rgba(0, 0, 0, 0.75);
  z-index: 10;
}

dialog {
  position: fixed;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  width: 22rem;
  z-index: 100;
  border-radius: 1rem;
  border: none;
  padding: 1.5rem;
  margin: 0;
  overflow: hidden;
}

/* header {
  background-color: #3a0061;
  color: white;
  width: 100%;
  padding: 1rem;
} */

header h2 {
  font-size: 1.3rem;
  color: var(--clr-neutral-500);
  font-weight: var(--fw-500);
}

section {
  padding-top: 1rem;
  padding-bottom: 0.5rem;
}

menu {
  padding: 0;
  /* display: flex; */
  /* justify-content: flex-end; */
  /* margin: 0; */
}

/* .dialog-enter-from,
.dialog-leave-to {
  opacity: 0;
  transform: scale(0.8);
} */

/* .dialog-enter-active {
  transition: all 0.3s ease-out;
} */

/* .dialog-leave-active {
  transition: all 0.3s ease-in;
} */

/* .dialog-enter-to,
.dialog-leave-from {
  opacity: 1;
  transform: scale(1);
} */

@media (min-width: 768px) {
  dialog {
    /* left: calc(50% - 20rem); */
    /* width: 40rem; */
  }
}
</style>
